function convolution_demo_CRC;

% Demonstration of digital convolution
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Call convolution_demo_CRC;

s=1;
while s==1,
m1=menu('Select','Principle of convolution','Local mean','Laplacian');
if m1~=1,
   m2=menu('Select image','Chest','MRI','Angiogram','Text','Barbara');
	switch m2
	case 1, load chest;INPIMG=chest;
	case 2, load brain; INPIMG=brain;
	case 3, load ango; INPIMG=ango;
	case 4, load text256; INPIMG=text256;
	case 5, load barbara; INPIMG=barbara;
   end
end
Lapl=[-0.1 -0.15 -0.1;-0.15 1 -0.15;-0.1 -0.15 -0.1 ];   
switch m1
case 1;
   load eye32;
   m3=menu('Select probability of "seed" points','0.0002','0.0004','0.0008','0.0016');
   fig_n(3);
   figure(1);
   INPIMG=double(rand(256)<0.0002*2^(m3-1));
   display_1(INPIMG); title('"Seed" image','FontWeight','Bold');colormap(colorcube);drawnow
   figure(2);display_1(kron([0 0 0;0 1 0;0 0 0],eye32));title('Filter PSF','FontWeight','Bold');drawnow
   figure(3);
   OUTIMG=conv2(INPIMG,eye32,'same');
   display_1(OUTIMG);title('Convolution result','FontWeight','Bold');
case 2
   fig_n(4);
   figure(1);display_1(INPIMG); title('Initial image','FontWeight','Bold');drawnow
   figure(2);
   OUTIMG=conv2(INPIMG,ones(3)/9);
   display_1(OUTIMG);
   title('Local mean 3x3','FontWeight','Bold');drawnow
   figure(3);
   OUTIMG=conv2(INPIMG,ones(5)/9,'same');
   display_1(OUTIMG);
   title('Local mean 5x5','FontWeight','Bold');drawnow
   figure(4);
   OUTIMG=conv2(INPIMG,ones(15)/225);
   display_1(OUTIMG);
   title('Local mean 15x15','FontWeight','Bold');drawnow
case 3,
   fig_n(3);
   figure(1);display_1(INPIMG);title('Initial image','FontWeight','Bold');drawnow
   figure(2);display_1(kron(Lapl,ones(11)));colormap(jet);
   title('PSF of the filter','FontWeight','Bold');colormap(jet);axis tight;drawnow
   set(gca,'FontWeight','Bold');
   figure(3);
   OUTIMG=conv2(INPIMG,Lapl,'same');
   disp_norm(OUTIMG,4);
   title('"Laplacian" of the image ','FontWeight','Bold');drawnow
end
s=menu('Finish','No','Yes');
end
   
%-----------------------------------------------------
   function fig_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
   
%------------------------------------------------------
function display_1(INPIMG)
% Displays a 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display_1(INPIMG)

colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
%------------------------------------------------------
function disp_norm(INPIMG,g)
% 2-D signal display with normalization by mean value and standard deviation
% g- is a parameter that defines ratio of the display range 0-255
% to the signal standard deviation 
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call dispnorm(INPIMG,g)

[SzX SzY]=size(INPIMG);
Mean=mean(mean(INPIMG));		
stdv=sqrt(mean(mean((INPIMG-Mean).^2)))+eps;
dspl=round(255*(INPIMG-Mean)/(g*stdv))+128;
dspl=(dspl>=0).*dspl;
dspl=(dspl<=255).*dspl+255*ones(SzX,SzY).*(dspl>255);
image(dspl);axis image; axis off;
