function lcoptcorr_CRC;

% Program campares global and local SCR optimal adaptive correlators
% Target is selected interactively from TARGIMG
% 
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  

close all
load mishka_left; INPIMG=mish_left;
load mishka_right; TARGIMG=mishka_right;
figure(1);
clf
imshow([INPIMG,TARGIMG],[],'InitialMagnification',200);
title('Input (left) and target(right) images','FontWeight','Bold');
drawnow

m1=menu('Target radius','7','9','11','13','15','17','19','21','23');
RR=[7,9,11,13,15,17,19,21,23];
R=RR(m1);
Lx=2*R;
Ly=2*R;
[SzX SzY]=size(INPIMG);
[SzX_trgt SzY_trgt]=size(TARGIMG);
WSzX=2*Lx+1;
WSzY=2*Ly+1;
sm_mask=[0.5 0.7 0.5;0.7 1 0.7;0.5 0.7 0.5];
INPIMG=img_ext(INPIMG,Lx,Ly);
INPIMG_zmn=INPIMG-conv2(INPIMG,ones(2*Lx+1,2*Ly+1)/((2*Lx+1)*(2*Ly+1)),'same');
% INPIMG_zmn=INPIMG-mean_ksn(INPIMG,2*Lx+1,2*Ly+1);
% --------------------------Formation of a target---------------------------------
imshow(TARGIMG,[],'InitialMagnification',200);
title('Select a position of the target','FontWeight','Bold');
drawnow
coor=fix(ginput(1));Xt=round(coor(2));Yt=round(coor(1));

mask=rad_apodmask_CRC(R);
TARGIMG_zmn=TARGIMG-conv2(TARGIMG,ones(2*Lx+1,2*Ly+1)/((2*Lx+1)*(2*Ly+1)),'same');
TARGET=zeros(2*Lx+1,2*Ly+1);
TARGET(Lx+1-R:Lx+1+R,Ly+1-R:Ly+1+R)=TARGIMG_zmn(Xt-R:Xt+R,Yt-R:Yt+R).*mask;

mask_trgt=ones(SzX_trgt,SzY_trgt);
mask_trgt(Xt-R:Xt+R,Yt-R:Yt+R)=mask_trgt(Xt-R:Xt+R,Yt-R:Yt+R)+0.5*mask;
figure_n(3);
figure(1);
imshow([uquan256(INPIMG(Lx+1:Lx+SzX,Ly+1:Ly+SzY)),uquan256(TARGIMG.*mask_trgt)],[]);
title('Input image (left) and target image (right; target highlighted)','FontWeight','Bold');

% ----------------------------CORRELATION------------------------------------

sp_targ=conj(fft2(TARGET));sp_targ(1,1)=0;
OUTIMG=zeros(SzX,SzY);
for X=1:SzX;
    for Y=1:SzY;
		frgm=INPIMG_zmn(X:X+WSzX-1,Y:Y+WSzY-1);
        sp_frgm=fft2(frgm);
        sp_fr2=fftshift(conv2(fftshift(abs(sp_frgm).^2),sm_mask,'same'));  
		sp_cor=sp_frgm.*sp_targ./(sp_fr2+eps);
%         OUTIMG(X,Y)=real(sum(sum(sp_cor)))/sqrt(sum(sum(abs(sp_cor).^2)));
        OUTIMG(X,Y)=(real(sum(sum(sp_cor))).^2)/sum(sum(abs(sp_cor).^2));
	end
	figure(2);
    imshow(OUTIMG,[]);colormap(jet);
    title('Local correlations','FontWeight','Bold');
    drawnow
end

S=1;

while S==1,
[Xm,Ym,mx]=locatmax_CRC(OUTIMG(R:SzX-R,R:SzY-R));
x=Xm+R-1;y=Ym+R-1;mmax=mx;
[mn stdev]=std2d(OUTIMG);
SNR=(mmax-mn)/stdev;
mask=ones(SzX,SzY);mask(x,:)=zeros(1,SzY);mask(:,y)=zeros(SzX,1);
figure(1);
imshow([uquan256(INPIMG(Lx+1:Lx+SzX,Ly+1:Ly+SzY).*mask),uquan256(TARGIMG.*mask_trgt)],[]);
title(['Local SCR-opt. adapt. correlator: localization result (marked by cross); SCR=',num2str(SNR,2)],'FontWeight','Bold');
drawnow
%-------------------------Global SCR-optimal correlator-------------------
trgt_mask=rad_apodmask_CRC(R);
TARGIMG_zmn=TARGIMG;
TARGET=zeros(SzX,SzY);TARGET(fix(SzX/2)+1,fix(SzY/2)+1)=1;
Xu=Xt-R;if Xu<1, Xu=1;end
Xd=Xt+R;if Xt+R>SzX,Xd=SzX;end
Yl=Yt-R;if Yt-R<1,Yl=1;end
Yr=Yt+R;if Yr>SzY,Yr=SzY;end
TARGET=conv2(TARGET,trgt_mask,'same');
% TARGET=(conv2(TARGET,TARGIMG_zmn(Xu:Xd,Yl:Yr),'same')).*mask;
mtchfilter=conj(fft2(TARGET));mtchfilter(1,1)=eps;
spimg=fft2(INPIMG(Lx+1:Lx+SzX,Ly+1:Ly+SzY));
spimg2=(abs(spimg)).^2;
spimg2=conv2(spimg2,ones(5)/25,'same');
% opt_corr=fftshift(real(ifft2(spimg.*mtchfilter./spimg2)));
opt_corr=fftshift(real(ifft2(spimg.*mtchfilter./spimg2))).^2;
[mn StDev_oac]=std2d(opt_corr);
[X_oac,Y_oac,Mmax_oac]=locatmax(opt_corr(fix(0.1*SzX):fix(0.9*SzX),fix(0.1*SzY):fix(0.9*SzY)));
X_oac=X_oac+fix(0.1*SzX)-1;Y_oac=Y_oac+fix(0.1*SzY)-1;
SNR_oac=Mmax_oac/StDev_oac;

mask_oac=ones(SzX,SzY);
YY_oac=Y_oac-7; if YY_oac<1,YY_oac=1;end;YYY_oac=Y_oac+7;if YYY_oac>SzY, YYY_oac=SzY;end
mask_oac(X_oac-1:X_oac+1,YY_oac:YYY_oac)=zeros(3,YYY_oac-YY_oac+1);
XX_oac=X_oac-7; if XX_oac<1,XX_oac=1;end;XXX_oac=X_oac+7;if XXX_oac>SzX, XXX_oac=SzX;end
mask_oac(XX_oac:XXX_oac,Y_oac-1:Y_oac+1)=zeros(XXX_oac-XX_oac+1,3);
%--------------------------------------------------------------------------
figure(2);
imshow([uquan256(opt_corr),uquan256(OUTIMG)],[]);colormap(jet);
title(['Global (left) and local (right; WSz=',num2str(2*Lx+1),'x',num2str(2*Ly+1),'; Rtrgt=',num2str(R),') correlations'],'FontWeight','Bold');
drawnow
figure(3)
imshow([uquan256(INPIMG(Lx+1:Lx+SzX,Ly+1:Ly+SzY).*mask_oac),uquan256(TARGIMG.*mask_trgt)],[]);
title('Global SCR-opt. adapt. correlator: localization result (marked by cross)','FontWeight','Bold');
drawnow
if abs(x-Xt)+abs(y-Yt)>R;
   str='False detection!';
else str='Correct detection!';
end
CORROUT=OUTIMG;
S=menu([str,' Do you want to look for the next maximum? (y or n)'],'y','n');
Xu=x-8; if Xu<=0,Xu=0;end
Xd=x+8; if Xd>=SzX, Xd=SzX;end
Yl=y-8; if Yl<=0,Yl=0;end
Yr=y+8; if Yr>=SzY, Yr=SzY;end
OUTIMG(Xu:Xd,Yl:Yr)=zeros(Xd-Xu+1,Yr-Yl+1);

end

%-------------------------------------------------
function [Xm,Ym,mx]=locatmax_CRC(INP)

% The program locates the highest maximum in a matrix INP
% Provides its value and coordinates
% OUT=[Xm Ym Maximum]
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call [Xm,Ym,mx]=locatmax(INP);

mx=max(max(INP));
[Xm,Ym]=find(INP==mx);
if size(Xm)>1,Xm=Xm(1);end
if size(Ym)>1,Ym=Ym(1);end  
%-----------------------------------------------------------
function OUT=rad_apodmask_CRC(R);

% Central symmetric apodization mask of (2R+1)x(2R+1) pixels
% Size of the "active" area is half of the mask size
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUT=rad_apodmask(R);


X=(-R:R).^2;
X=kron(X,ones(2*R+1,1));
r=X+X';
r=1-r/max(max(r));
OUT=atan(15*(((r.*(r<0.95)+0.95*(r>=0.95)))/0.95).^20);
OUT=OUT/max(max(OUT));

%---------------------------------------------------------
function OUTIMG=img_ext(INPIMG,Lx,Ly);

% Image extention by mirror reflection from its borders
% by Lx,Ly pixels from the corresponding sides
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=img_ext(INPIMG,Lx,Ly);

[SzX,SzY]=size(INPIMG);

OUTIMG=[fliplr(INPIMG(:,1:Ly)),INPIMG,fliplr(INPIMG(:,SzY-Ly+1:SzY))];
OUTIMG=[flipud(OUTIMG(1:Lx,:));OUTIMG;flipud(OUTIMG(SzX-Lx+1:SzX,:))];
%-----------------------------------------------------------------------------------        
 function figure_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating figure windows
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
%-------------------------------------------------------------------------------

function OUTIMG=uquan256(INPIMG);

% Uniform quantization of a signal into a range [0-255];
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call OUTIMG=uquan256(INPIMG);

mn=min(min(INPIMG));
mx=max(max(INPIMG));
 
OUTIMG=round(255*(INPIMG-mn)/(mx-mn));
%-----------------------------------------------------------------------------------
%--------------------------------------------------------------
function [mn,v]=std2d(INP);

% Standard deviation and mean of a 2-D array
% z=[mean stdeviation];
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call [mn v]=std2d(INP)

[SzX SzY]=size(INP);
mn=sum(sum(INP))/(SzX*SzY);
v=sqrt(sum(sum((INP-mn).^2))/(SzX*SzY));
%----------------------------------------------------------------
function [Xm,Ym,mx]=locatmax(INP)

% The program locates the highest maximum in a matrix INP
% Provides its value and coordinates
% OUT=[Xm Ym Maximum]
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call [Xm,Ym,mx]=locatmax(INP);

mx=max(max(INP));
[Xm,Ym]=find(INP==mx);
if size(Xm)>1,Xm=Xm(1);end
if size(Ym)>1,Ym=Ym(1);end   

%----------------------------------------------------------