function filtering_stripes_CRC;

% Filtering banding noise by substruction of difference between average
% along bands and its smoothed copy
% 2 modes of smoothing: local mean and local median in window of SmWSz
% samples (odd number)
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)


figure_n(4);
load StripeNoiseImg;
INPIMG=StripeNoiseImg;
figure(1);
display1(INPIMG);
title('Input image','FontWeight','Bold');
[SzX,SzY]=size(INPIMG);

s=1;
while s==1,
    
    SmWSz=inputdlg('Enter size of the smothing window (odd number)');
    SmWSz=str2double(SmWSz);
    Lext=(SmWSz-1)/2;
    AvRows=mean(INPIMG,2);
    AvRows_sm=AvRows;
    m=menu('Smoothing by means of','LocMean','LocMedian');
    AvRows_ext=[flipud(AvRows(1:Lext));AvRows;flipud(AvRows(SzX-Lext+1:SzX))];
    switch m;
        case 1,AvRows_sm=conv2(AvRows_ext,ones(SmWSz,1)/SmWSz,'valid');
        case 2,
            for x=1:SzX,
                AvRows_sm(x)=median(AvRows_ext(x:x+SmWSz-1));
            end
    end
    figure(2)
    plot(1:SzX,AvRows,'r',1:SzX,AvRows_sm,'b','LineWidth',2);
    xlabel('Row index','FontWeight','Bold')
    axis tight
    title(['Size of the smoothing window =',num2str(SmWSz)],'FontWeight','Bold');
    grid on
    legend('Av. image rows','Smoothed Av. image rows')
    set(gca,'FontWeight','Bold');
    Correction=kron(AvRows-AvRows_sm,ones(1,SzY));
    OUTIMG=INPIMG-Correction;
    figure(3);
    display1(OUTIMG)
    title('Corrected image','FontWeight','Bold')
    figure(4)
    display1(Correction);
    title('Noise removed','FontWeight','Bold')
    s=menu('Another window size?','Yes','No');
end

%--------------------------------------------------------------------------
function figure_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating a figure window
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
%----------------------------------------------------------------
%----------------------------------------------------------
function display1(INPIMG)
% Displays a 2-D signal as an image 
% with normalization by gobal maximum and minimum
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il) 
% Call display1(INPIMG)

clf
colormap(gray(256))
Min=min(min(INPIMG)); Max=max(max(INPIMG));
if Max-Min==0, im=zeros(size(INPIMG)); else im=255*(INPIMG-Min)/(Max-Min); end

image(im);axis image;axis off;
